#ifndef COMMON_H
#define COMMON_H
#ifndef __G_COMMON_H__
#define __G_COMMON_H__

#ifdef WIN32

#ifdef USE_SOCK
#include <winsock.h>
#endif//USE_SOCK

#include <windows.h>
#else//for Linux( uncomplete )

#ifdef USE_SOCK
#include <socket.h>
#define SOCK int
#endif//USE_SOCK

#include <unistd.h>

#endif //WIN32

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>

#define _abs(expr) ((expr) > 0 ? (expr) : -(expr))

#define E_ABORT_IO -1
#define E_INVALID_IN -2

inline long long Q_pow(long base, long index);

#ifdef USING_NS_STD
using namespace std;
#endif
#ifdef USING_NS_YX
using namespace yx;
#endif

#endif //__G_COMMON_H__
#include "console.h"
#include <time.h>

#define M_UC 0
#define M_C  1

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

#define LZR_SYMBOL "LZR"

#ifdef __DEBUG__
#define debug(...) printf("[DEBUG] "__VA_ARGS__)
#else
#define debug(...)
#endif

struct LZRHD
{
	unsigned char symb[4];
	unsigned long flag_bits;
	unsigned long data_leng;
	unsigned long orig_leng;
};
#endif /*COMMON_H*/
