#ifndef __CONSOLE_H__
#define __CONSOLE_H__

#include "common.h"

#include<string>

namespace yx
{
	namespace IO
	{
		int open_strict(std::string filename, int type);
		
		int write_strict(int fd, unsigned char* buffer, long len);
	}
	
	namespace File
	{
		std::string get_extention(std::string filename);
		
		std::string get_prefix(std::string filename);
		
		std::string get_path(std::string filename);
	}
	
	namespace String
	{
		std::string itos(int value);
	}
	
	namespace gra
	{
		void progress_bar(int prog, int total);
	}
}

#endif
